# Copyright (c) 2006-2010 oc2pus
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to toni@links2linux.de

# norootforbuild

%define _SO_nr		2
%define _ucil_SO_nr 2
%define _gtk_SO_nr	2

Name:			unicap
Summary:		A uniform API for all kinds of video capture devices
Group:			Productivity/Multimedia/Sound/Utilities
URL:			http://www.unicap-imaging.org
Version:		0.9.8
Release:		7.4
License:		GPL
Source0:		http://www.unicap-imaging.org/downloads/libunicap-%{version}.tar.gz
Source1:		http://www.unicap-imaging.org/downloads/libucil-%{version}.tar.gz
Source2:		http://www.unicap-imaging.org/downloads/libunicapgtk-%{version}.tar.gz
BuildRoot:		%{_tmppath}/%{name}-%{version}-buildroot
BuildRequires:	alsa-devel
BuildRequires:	dos2unix
BuildRequires:	fdupes
BuildRequires:	glib2-devel
BuildRequires:	gtk2-devel
BuildRequires:	intltool
BuildRequires:	libdca-devel
#BuildRequires:	libffmpeg0-devel
BuildRequires:	libogg-devel
BuildRequires:	libraw1394-devel
BuildRequires:	libtheora-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libx264-devel
BuildRequires:	libxml2-devel
BuildRequires:	perl-XML-Parser

%description
unicap provides a uniform API for all kinds of video capture devices.

The API was designed keeping simplicity in mind so that developers
can focus on their actual image processing tasks when using video
capture devices.

Device drivers are handled via a plugin mechanism. Support for new
devices can be added on the fly, without recompilation of the
library.
The API remains the same for each device so that an application using
unicap immediately works with all devices supported by unicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicap-doc
Summary:	Documentation for libunicap
Group:		Documentation/HTML
Requires:	libunicap%{_SO_nr} = %{version}
Requires:	libunicapgtk%{_gtk_SO_nr} = %{version}
Provides:	unicap-doc = 0.2.13
Obsoletes:	unicap-doc < 0.2.13

%description -n libunicap-doc
This package contains the documentation for using libunicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicap%{_SO_nr}
Summary:	Libunicap provides a uniform API for all kinds of video capture devices
Group:		System/Libraries
Provides:	libunicap1 = 0.9.5
Obsoletes:	libunicap1 < 0.9.5

%description -n libunicap%{_SO_nr}
unicap provides a uniform API for all kinds of video capture devices.

The API was designed keeping simplicity in mind so that developers
can focus on their actual image processing tasks when using video
capture devices.

Device drivers are handled via a plugin mechanism. Support for new
devices can be added on the fly, without recompilation of the
library. 
The API remains the same for each device so that an application using
unicap immediately works with all devices supported by unicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicap-devel
Summary:	Include Files and Libraries mandatory for Development
Group:		Development/Languages/C and C++
Requires:	libunicap%{_SO_nr} = %{version}

%description -n libunicap-devel
This package contains the files needed to compile programs that use
the unicap library.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libucil%{_ucil_SO_nr}
Summary:	Image processing library for unicap
Group:		System/Libraries
#Requires:	faac
#Requires:	faad2
#Requires:	lame
#Requires:	xvid
Provides:	libucil1 = 0.9.5
Obsoletes:	libucil1 < 0.9.5

%description -n libucil%{_ucil_SO_nr}
Image processing library for unicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libucil-devel
Summary:	Include Files and Libraries mandatory for development
Group:		Development/Languages/C and C++
Requires:	glib2-devel
Requires:	libdts-devel
Requires:	libtheora-devel
Requires:	libucil%{_ucil_SO_nr} = %{version}
Requires:	libunicap-devel = %{version}
Requires:	libx264-devel
Requires:	pango-devel
Requires:	xvid-devel

%description -n libucil-devel
This package contains the files needed to compile programs that use
the libucil library.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libucil-doc
Summary:	Documentation for libucil
Group:		Documentation/HTML

%description -n libucil-doc
This package contains the documentation for using libucil.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicapgtk%{_gtk_SO_nr}
Summary:	Gtk components for libunicap
Group:		System/Libraries
Requires:	libucil%{_ucil_SO_nr} = %{version}
Requires:	libunicap%{_SO_nr} = %{version}
Provides:	libunicapgtk1 = 0.9.5
Obsoletes:	libunicapgtk1 < 0.9.5

%description -n libunicapgtk%{_gtk_SO_nr}
Gtk components for libunicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicapgtk-devel
Summary:	Include Files and Libraries mandatory for development
Group:		Development/Languages/C and C++
Requires:	gtk2-devel
Requires:	libucil-devel = %{version}
Requires:	libunicapgtk%{_gtk_SO_nr} = %{version}
Requires:	libunicap-devel = %{version}

%description -n libunicapgtk-devel
Gtk components for libunicap.

Author: Arne Caspari <arne@unicap-imaging.org>

%package -n libunicapgtk-doc
Summary:	Documentation for libunicap-gtk
Group:		Documentation/HTML

%description -n libunicapgtk-doc
This package contains the documentation for using libunicap-gtk.

Author: Arne Caspari <arne@unicap-imaging.org>

%debug_package
%lang_package

%prep
%setup -q -n lib%{name}-%{version} -a1 -a2
%{?suse_update_config:%{suse_update_config -f}}

#%__sed -i -e 's|PIX_FMT_YUV422|PIX_FMT_YUYV422|g' \
#	libucil-0.9.8/src/colorspace.c

# png-1.4
%__sed -i -e 's|png_infopp_NULL|NULL|g' \
    libucil-%{version}/src/ucil_png.c
%__sed -i -e 's|png_voidp_NULL|NULL|g' \
    libucil-%{version}/src/ucil_png.c

%build
perl -p -i -e "s|\/lib\/|\/%{_lib}\/|g" \
	cpi/dcam/Makefile.am \
	cpi/dcam/Makefile.in \
	cpi/thing/Makefile.am \
	cpi/thing/Makefile.in \
	cpi/v4l/Makefile.am \
	cpi/v4l/Makefile.in \
	cpi/vid21394/Makefile.am \
	cpi/vid21394/Makefile.in

%configure \
	--disable-static \
	--enable-vid21394-visca \
	--enable-vid21394-21cf04 \
	--enable-vid21394 \
	--enable-dcam \
	--enable-v4l \
	--enable-v4l2 \
	--enable-thing=no \
	--enable-unicap-threads \
	--disable-rpath
#	--enable-gtk-doc

%__make %{?jobs:-j%{jobs}}

%install
%makeinstall

pushd libucil-%{version}
	export UNICAP_CFLAGS="-I%{buildroot}%{_includedir}/unicap"
	export UNICAP_LIBS="-L%{buildroot}%{_libdir} -lunicap -lrt"

	%configure \
		--disable-static \
		--enable-ucil-avcodec \
		--enable-ucil-theora \
		--enable-ucil-alsa \
		--enable-ucil-png \
		--enable-ucil \
		--disable-rpath

	%__sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
	%__sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

	%__make %{?jobs:-j%{jobs}}
	%makeinstall
popd

pushd libunicapgtk-%{version}
	export UNICAP_PACKAGE_CFLAGS="-I%{buildroot}%{_includedir}/unicap"
	export UNICAP_PACKAGE_LIBS="-L%{buildroot}%{_libdir} -lunicap -lrt -lucil -lm"

	%configure \
		--disable-static \
		--disable-rpath

	%__sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
	%__sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

	%__make %{?jobs:-j%{jobs}} || :
	touch src/.libs/libunicapgtk.lai
	%makeinstall
popd

%__rm %{buildroot}%{_libdir}/*.la
%__rm %{buildroot}%{_libdir}/unicap2/cpi/*.la

%find_lang %{name}    %{name}.lang
%find_lang %{name}gtk %{name}.lang

find doc -name '*.css' | xargs dos2unix
%fdupes -s %{buildroot}

%clean
[ -d "%{buildroot}" -a "%{buildroot}" != "" ] && %__rm -rf "%{buildroot}"

%post -n libucil%{_ucil_SO_nr} -p /sbin/ldconfig

%post -n libunicap%{_SO_nr} -p /sbin/ldconfig

%post -n libunicapgtk%{_gtk_SO_nr} -p /sbin/ldconfig

%postun -n libucil%{_ucil_SO_nr} -p /sbin/ldconfig

%postun -n libunicap%{_SO_nr} -p /sbin/ldconfig

%postun -n libunicapgtk%{_gtk_SO_nr} -p /sbin/ldconfig

%files lang -f %{name}.lang

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%dir %{_libdir}/%{name}2
%dir %{_libdir}/%{name}2/cpi
%{_libdir}/%{name}2/cpi/libdcam*.so
%{_libdir}/%{name}2/cpi/libv4l.so
%{_libdir}/%{name}2/cpi/libv4l2cpi.so
%{_libdir}/%{name}2/cpi/libvid21394.so

%files -n libunicap-doc
%defattr(-,root,root)
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%doc %{_datadir}/gtk-doc/html/libunicap

%files -n libunicap%{_SO_nr}
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%{_libdir}/libunicap.so.*

%files -n libunicap-devel
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%{_libdir}/libunicap.so
%dir %{_includedir}/unicap
%{_includedir}/%{name}/unicap.h
%{_includedir}/%{name}/unicap_status.h
%{_includedir}/%{name}/unicap_version.h
%{_libdir}/pkgconfig/libunicap.pc

%files -n libunicapgtk-doc
%defattr(-,root,root)
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%doc %{_datadir}/gtk-doc/html/libunicapgtk

%files -n libunicapgtk%{_gtk_SO_nr}
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%{_libdir}/libunicapgtk.so.*

%files -n libunicapgtk-devel
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/unicapgtk.h
%{_includedir}/%{name}/unicapgtk_device_property.h
%{_includedir}/%{name}/unicapgtk_device_selection.h
%{_includedir}/%{name}/unicapgtk_property_dialog.h
%{_includedir}/%{name}/unicapgtk_version.h
%{_includedir}/%{name}/unicapgtk_video_display.h
%{_includedir}/%{name}/unicapgtk_video_format_selection.h
%{_libdir}/libunicapgtk.so
%{_libdir}/pkgconfig/libunicapgtk.pc

%files -n libucil-doc
%defattr(-,root,root)
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%doc %{_datadir}/gtk-doc/html/libucil

%files -n libucil%{_ucil_SO_nr}
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%{_libdir}/libucil.so.*

%files -n libucil-devel
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README*
%dir %{_includedir}/unicap
%{_includedir}/%{name}/ucil.h
%{_includedir}/%{name}/ucil_png.h
%{_includedir}/%{name}/ucil_version.h
%{_includedir}/%{name}/ucil_alsa.h
%{_libdir}/libucil.so
%{_libdir}/pkgconfig/libucil.pc

%changelog
* Fri Feb 19 2010 Toni Graffy <toni@links2linux.de> - 0.9.8-0.pm.1
- update to 0.9.8
- removed static libraries
* Mon Sep 28 2009 Andrea Florio <andrea@links2linux.de> - 0.9.7
- update to 0.9.7
* Tue Apr 21 2009 Toni Graffy <toni@links2linux.de> - 0.9.5-0.pm.1
- update to 0.9.5
* Sat Oct 04 2008 Toni Graffy <toni@links2linux.de> - 0.9.3-0.pm.1
- update to 0.9.3
* Thu Aug 28 2008 Toni Graffy <toni@links2linux.de> - 0.9.0-0.pm.1
- update to 0.9.0
* Thu Jul 10 2008 Toni Graffy <toni@links2linux.de> - 0.2.24-0.pm.1
- update to 0.2.24
* Mon May 19 2008 Toni Graffy <toni@links2linux.de> - 0.2.23-0.pm.1
- update to 0.2.23
* Thu May 15 2008 Toni Graffy <toni@links2linux.de> - 0.2.22-0.pm.1
- update to 0.2.22
* Sun Feb 03 2008 Toni Graffy <toni@links2linux.de> - 0.2.19-0.pm.1
- update to 0.2.19
* Sat Dec 29 2007 Toni Graffy <toni@links2linux.de> - 0.2.17-0.pm.2
- rebuild with new libx264(-devel) package
* Thu Oct 11 2007 Toni Graffy <toni@links2linux.de> - 0.2.17-0.pm.1
- update to 0.2.17
- renamed unicap-doc to libunicap-doc
- new subpackages libuclib-doc and libunicap-gtk-doc
* Sun Aug 05 2007 Toni Graffy <toni@links2linux.de> - 0.2.13-0.pm.1
- update to 0.2.13
- avcodec is currently not correctly supported and disabled by default.
  It is not required for ucview: ucview uses theora for video encoding.
* Fri Jul 06 2007 Toni Graffy <toni@links2linux.de> - 0.2.11-0.pm.1
- update to 0.2.11
- disbled video-4-linux v2 for SuSE <= 1010
* Tue Jun 05 2007 Toni Graffy <toni@links2linux.de> - 0.2.7-0.pm.2
- changed package layout according Shared Library Packaging Policy
* Sat May 26 2007 Toni Graffy <toni@links2linux.de> - 0.2.7-0.pm.1
- update to 0.2.7
* Tue May 13 2007 Toni Graffy <toni@links2linux.de> - 0.2.6-0.pm.1
- update to 0.2.6
- disabled "thing"
* Wed Apr 18 2007 Toni Graffy <toni@links2linux.de> - 0.2.5-0.pm.1
- update to 0.2.5
* Tue Apr 03 2007 Toni Graffy <toni@links2linux.de> - 0.2.4-0.pm.1
- update to 0.2.4
* Thu Feb 22 2007 Toni Graffy <toni@links2linux.de> - 0.2.3-0.pm.1
- update to 0.2.3
* Mon Feb 05 2007 Toni Graffy <toni@links2linux.de> - 0.2.2-0.pm.1
- update to 0.2.2
* Sat Jan 13 2007 Toni Graffy <toni@links2linux.de> - 0.2.1-0.pm.1
- update to 0.2.1
* Wed Jan 03 2007 Toni Graffy <toni@links2linux.de> - 0.2.0-0.pm.1
- update to 0.2.0
* Wed Nov 22 2006 Toni Graffy <toni@links2linux.de> - 0.1.17-0.pm.2
- corrected url
* Tue Nov 21 2006 Toni Graffy <toni@links2linux.de> - 0.1.17-0.pm.1
- update to 0.1.17
* Thu Oct 19 2006 Toni Graffy <toni@links2linux.de> - 0.1.16-0.pm.1
- initial package 0.1.16
